package main

import (
	"fmt"
	"strings"
)


func punteggioLettera(lettera rune) int {
	switch lettera {
		case 'L', 'M', 'N':
			return 2
		case 'P':
			return 3
		case 'B', 'D', 'F', 'G', 'U', 'V':
			return 4
		case 'H', 'Z':
			return 8
		case 'Q':
			return 10
		default:
			return 1
	}
}

func moltiplica(punteggio int, moltiplicatore int) int {
	return punteggio*moltiplicatore
}

func applicaMoltiplicatore(punteggio *([]int), moltiplicatori []int, moltiplica func(int, int)int) {
	for i, _ := range(*punteggio) {
		(*punteggio)[i] = moltiplica((*punteggio)[i], moltiplicatori[i])
	}
}

func calcolaPunteggio(punteggioLettera func(rune)int, runeParola []rune) []int {
	var result []int = make([]int,0)

	for _, v := range(runeParola) {
		result = append(result, punteggioLettera(v))
	}
	
	return result
}

func extractMultipliers(multi string) []int {
	var result []int = make([]int,0)
	for _, v := range(multi) {
		result = append(result, int(v-'0'))
	}
	return result
}

func main(){
	var word string
	var multipliers string
	
	fmt.Println("Insert a word")
	fmt.Scan(&word)
	fmt.Println("Insert multipliers")
	fmt.Scan(&multipliers)
	
	var chars []rune = []rune(strings.ToUpper(word))
	
	var punteggi []int = calcolaPunteggio(punteggioLettera, chars)
	
	var moltiplicatori []int = extractMultipliers(multipliers)

	fmt.Println(punteggi)

	applicaMoltiplicatore(&punteggi, moltiplicatori, moltiplica)
	
	var tot int
	fmt.Println(punteggi)
	for _,v :=range(punteggi){
		tot+=v
	}
	fmt.Println("Totale ",tot)
}

